% Angewandte Numerik 1, SoSe 2017
% Uebungsblatt 04, Aufgabe 19: Vergleich der Rechenzeiten
%
% Testprogramm fuer die Funktion L = cholesky(A),
% die die CholeskyZerlegung einer symmetrischen positiv definiten
% Matrix A berechnet



clear;
close all;
clc;



%% Initialisierungen

tol = 1e-13;                    % Toleranz fuer Genauigkeit der Ergebnisse



%% Tests

testfall = 0;
while 1                         % alle Testfaelle untersuchen
    testfall = testfall + 1;    % naechster Testfall
    
    
    %% alle Testfaelle definieren
    
    switch testfall
        case 1                  % Testfall 1
            A = [2 6 -2; 6 21 0; -2 0 16];
        case 2                  % Testfall 2
            A = hilb(10);
        case 3                  % Testfall 3
            n = 35;             % Matrix der Dimension n x n
            A = rand(n);
            A = A + A' + 2 * n * eye(n);
        otherwise
            break;              % keine Testfaelle mehr vorhanden
    end
    
    
    
    %% Testfall durchfuehren und Ergebnis ausgeben

    L = cholesky(A);
    
    err = max(max(abs(L*L'-A)));
    spezString = 'Testfall %d: Mit Fehler %g %s.\n';
    if  err < tol
        fprintf(spezString, testfall, err, 'Bestanden');  
    else
        fprintf(2, spezString, testfall, err, 'Fehlgeschlagen');
    end

end
